import ButtonBackHeader from "@/components/buttonBackHeader";
import ButtonSaveHeader from "@/components/buttonSaveHeader";
import ButtonSelect from "@/components/buttonSelect";
import { InputForm } from "@/components/inputForm";
import ModalSelectMultiple from "@/components/modalSelectMultiple";
import Text from "@/components/Text";
import Styles from "@/constants/Styles";
import { setUpdateAnnouncement } from "@/lib/announcementUpdate";
import { apiCreateAnnouncement } from "@/lib/api";
import { useAuthSession } from "@/providers/AuthProvider";
import { Entypo } from "@expo/vector-icons";
import { router, Stack } from "expo-router";
import { useEffect, useState } from "react";
import { SafeAreaView, ScrollView, StyleSheet, View } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";

export default function CreateAnnouncement() {
   const dispatch = useDispatch()
   const update = useSelector((state: any) => state.announcementUpdate)
   const { token, decryptToken } = useAuthSession()
   const [disableBtn, setDisableBtn] = useState(true);
   const [modalDivisi, setModalDivisi] = useState(false);
   const [divisionMember, setDivisionMember] = useState<any>([])
   const [loading, setLoading] = useState(false)
   const [dataForm, setDataForm] = useState({
      title: "",
      desc: "",
   });
   const [error, setError] = useState({
      title: false,
      desc: false,
   });

   function validationForm(cat: string, val: any) {
      if (cat == "title") {
         setDataForm({ ...dataForm, title: val });
         if (val == "" || val == "null") {
            setError({ ...error, title: true });
         } else {
            setError({ ...error, title: false });
         }
      } else if (cat == "desc") {
         setDataForm({ ...dataForm, desc: val });
         if (val == "" || val == "null") {
            setError({ ...error, desc: true });
         } else {
            setError({ ...error, desc: false });
         }
      }
   }

   function checkForm() {
      if (
         Object.values(error).some((v) => v == true) ||
         Object.values(dataForm).some((v) => v == "")
      ) {
         setDisableBtn(true);
      } else {
         setDisableBtn(false);
      }
   }

   useEffect(() => {
      checkForm();
   }, [error, dataForm]);

   async function handleCreate() {
      try {
         setLoading(true)
         const hasil = await decryptToken(String(token?.current))
         const response = await apiCreateAnnouncement({
            data: { ...dataForm, user: hasil, groups: divisionMember },
         });
         if (response.success) {
            dispatch(setUpdateAnnouncement(!update))
            Toast.show({ type: 'small', text1: 'Berhasil menambahkan data', })
            router.back();
         }
      } catch (error) {
         console.error(error);
      } finally {
         setLoading(false)
      }
   }

   return (
      <SafeAreaView>
         <Stack.Screen
            options={{
               headerLeft: () => (
                  <ButtonBackHeader
                     onPress={() => {
                        router.back();
                     }}
                  />
               ),
               headerTitle: "Tambah Pengumuman",
               headerTitleAlign: "center",
               headerRight: () => (
                  <ButtonSaveHeader
                     disable={disableBtn || divisionMember.length == 0 || loading ? true : false}
                     category="create"
                     onPress={() => {
                        divisionMember.length == 0
                           ? Toast.show({ type: 'small', text1: "Anda belum memilih divisi", })
                           : handleCreate();
                     }}
                  />
               ),
            }}
         />
         <ScrollView
            showsVerticalScrollIndicator={false}
            style={[Styles.h100]}
         >
            <View style={[Styles.p15]}>
               <InputForm
                  label="Judul"
                  type="default"
                  placeholder="Judul Pengumuman"
                  required
                  error={error.title}
                  errorText="Judul harus diisi"
                  onChange={(val) => validationForm("title", val)}
               />
               <InputForm
                  label="Pengumuman"
                  type="default"
                  placeholder="Deskripsi Pengumuman"
                  required
                  error={error.desc}
                  errorText="Pengumuman harus diisi"
                  onChange={(val) => validationForm("desc", val)}
                  multiline
               />
               <ButtonSelect
                  value="Pilih divisi penerima pengumuman"
                  onPress={() => {
                     setModalDivisi(true)
                  }}
               />

               {
                  divisionMember.length > 0
                  &&
                  <View style={[Styles.borderAll, Styles.round10, Styles.p10]}>
                     {
                        divisionMember.map((item: { name: any; Division: any }, index: any) => {
                           return (
                              <View key={index}>
                                 <Text style={[Styles.textDefaultSemiBold]}>{item.name}</Text>
                                 {
                                    item.Division.map((division: any, i: any) => (
                                       <View key={i} style={[Styles.rowItemsCenter, Styles.w90]}>
                                          <Entypo name="dot-single" size={24} color="black" />
                                          <Text style={[Styles.textDefault]} numberOfLines={1} ellipsizeMode='tail'>{division.name}</Text>
                                       </View>
                                    ))
                                 }
                              </View>
                           )
                        })
                     }
                  </View>
               }
            </View>
         </ScrollView>

         <ModalSelectMultiple
            choose="dinas"
            title="Pilih Divisi"
            category="choose-division"
            open={modalDivisi}
            close={setModalDivisi}
            onSelect={(val) => {
               setDivisionMember(val)
               setModalDivisi(false)
            }}
         />
      </SafeAreaView>
   );
}

const styles = StyleSheet.create({
   container: {
      padding: 20,
   },
   textArea: {
      height: 100, // Or use flex-based sizing
      borderColor: 'gray',
      borderWidth: 1,
      padding: 10,
      textAlignVertical: 'top', // Important for Android to align text at the top
   },
});
